From 7a680d06e4b6ecf9e88e1c309f214d4e1a7f8700 Mon Sep 17 00:00:00 2001
From: NightMachinary <rudiwillalwaysloveyou@gmail.com>
Date: Wed, 29 Sep 2021 17:54:29 +0330
Subject: [PATCH 2/2] Added option
 dired-create-destination-dirs-trailing-separator-special

---
 lisp/dired-aux.el | 18 ++++++++++++++++--
 1 file changed, 16 insertions(+), 2 deletions(-)

diff --git a/lisp/dired-aux.el b/lisp/dired-aux.el
index fcaa8dd008..ee727ec5cc 100644
--- a/lisp/dired-aux.el
+++ b/lisp/dired-aux.el
@@ -1789,6 +1789,17 @@ If `ask', ask for user confirmation."
   :group 'dired
   :version "27.1")
 
+(defcustom dired-create-destination-dirs-trailing-separator-special nil
+  "If t, when selecting a single destination in Dired, paths that end in a path separator will be treated as a non-existent directory, and acted on according to `dired-create-destination-dirs'.
+
+This option is only relevant if `dired-create-destination-dirs' is not `nil', and you are moving/copying a single directory.
+
+For example, when renaming a directory named `old_name' to `new_name/' (note the trailing path separator), `new_name' might be created depending on `dired-create-destination-dirs' and `old_name' will be moved into it if it is created; Otherwise `old_name' will be directly renamed to `new_name'."
+  :type '(choice (const :tag "Do not treat paths with a trailing path separator specially" nil)
+                 (const :tag "Treat paths with a trailing path separator specially" t))
+  :group 'dired
+  :version "28.1")
+
 (defun dired-maybe-create-dirs (dir)
   "Create DIR if doesn't exist according to `dired-create-destination-dirs'."
   (when (and dired-create-destination-dirs (not (file-exists-p dir)))
@@ -2157,8 +2168,11 @@ Optional arg HOW-TO determines how to treat the target.
 		     target-dir op-symbol arg rfn-list default))))
 	 (into-dir
           (progn
-            (when (or (not dired-one-file)
-                      (directory-name-p target))
+            (when
+                (or
+                 (not dired-one-file)
+                 (and dired-create-destination-dirs-trailing-separator-special
+                      (directory-name-p target)))
               (dired-maybe-create-dirs target))
             (cond ((null how-to)
 		   ;; Allow users to change the letter case of
-- 
2.32.0

